#!/usr/bin/env python3
#-*- coding:utf-8 -*-
"""
Este programa es un  „hack“, y el código no es bonito, pero funciona.
En algún momento pasaré a jinja2 o a hacerme un CRM.
2017, 2018, 2019, 2020, 2022

Disponible en https://www.danielclemente.com/scripts/estruweb.py

Ver en „estruweb“, esto va de formalizar mi web.
Son todo pruebas y no sé si me será útil para algo. De momento lo uso para generar /mapa/.
"""
import os
import re
from collections import OrderedDict
from datetime import datetime
from pathlib import Path
import csv
import copy

import json

# Los datos van así:
#
# En temas:
# curiosidades==personal,
# mi_web==webdcl==página==estaweb,
# lengualógica==idiomas==lógica,
# programas==software,  ← aquí meto lo de ética (respeto en tecnología) por ahora. Podría crea nueva, „filosofía“
# www==web==html
TEMAS = ['lengualógica', 'personal', 'servidores', 'mi_web', 'aparatos', 'programas', 'www', ]
# importancias: 1,2,3 (3==mucho)
IDIOMAS = ['es', 'ca', 'eo', 'en', 'de', 'id', 'it', ]  # ver assert:
assert len(IDIOMAS) == 7, "Atención, si añado idiomas he de cambiar abajo el #col de ordenación secundaria"

# Lista de secciones de mi web; es una estructura fija mantenida a mano
# Sobre los atributos:
# - ver los básicos (nombre, importancia, caducidad, …) en el HTML.
# - además grabo título_corto_en_menú y título_extra_menú (van juntos). El 1º es versión breve (con máximo de letras)
#   y el 2º le añade un poquito más de detalle al 1º. Se usa en el menú de secciones (menu-v2.js). Estos dos son para
#   hacer el tema atractivo, mientras que el campo 'título' es un título más claro, objetivo y de longitud media
#
# Esto antes era una función. En vez de eso, mejor tomar esta variable, hacer una copia, y manipular la copia.
LISTA_DE_SECCIONES_YA_ESCRITAS = {
    '142857': {
        'título': 'Sobre el número 142857',
        'título_corto_en_menú': '142857',
        'título_extra_menú': 'Es mi nick. ¿Quieres saber de dónde viene?',
        'ruta': '142857/',
        'tema': 'personal',
        'importancia': 1,
        'idiomas': ['es'],
        'creación': 2002,
        'caducidad': None,
    },
    'servidor': {
        'título': 'Servidor para mi instituto, GNU/Linux, Apache, cortafuegos, …',
        'título_corto_en_menú': 'Servidor instituto',
        'título_extra_menú': 'Un trabajo sobre un ordenador con Debian',
        'ruta': 'servidor/',
        'importancia': 1,
        'tema': 'servidores',
        'idiomas': ['es', 'ca'],
        'creación': 2003,
        'caducidad': None,
    },
    # no pongo lo de „recerca.html“
        'amarok': {
            'título': 'Cómo monté mi servidor web',
            'título_corto_en_menú': 'Mi servidor',
            'título_extra_menú': 'Proceso de montaje del servidor de mi casa (para esta web)',
            'ruta': 'amarok/',
            'importancia': 3,  # mmm… no es muy importante, pero creo que a la gente le gusta
            'tema': 'servidores',
            'idiomas': ['es'],
            'creación': 2004,
            'caducidad': None,
        },
    'amarok-resulta': {
        'título': 'Qué tal funcionó mi servidor tras 2 años y medio',
        'título_corto_en_menú': '… y qué tal funcionó',
        'título_extra_menú': 'Resultados que conseguí y problemas que me dio mi servidor después de 30 meses',
        'ruta': 'amarok/resulta.html',
        'importancia': 2,
        'tema': 'servidores',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'ataque': {
        'título': 'Un ataque distribuido a mi web',
        'título_corto_en_menú': 'Ataque DDS',
        'título_extra_menú': 'Ataque distribuido de denegación de servicio que sufrió mi servidor web',
        'ruta': 'ataque/',
        'importancia': 1,
        'tema': 'servidores',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'barrapunto': {
        'título': 'El efecto Barrapunto en mi servidor',
        'título_corto_en_menú': 'Efecto Barrapunto',
        'título_extra_menú': 'Cómo saturé mi servidor a cambio de fama',
        'ruta': 'barrapunto/',
        'importancia': 1,
        'tema': 'servidores',
        'idiomas': ['es'],
        'creación': 2004,
        'caducidad': None,
    },
    'apuntes': {
        'título': 'Apuntes de la universidad, escaneados',
        'ruta': 'apuntes/',
        'título_corto_en_menú': 'Apuntes',
        'título_extra_menú': 'Las notas que tomo en clase (en la universidad)',
        'importancia': 1,
        'tema': 'personal',
        'idiomas': ['es', 'ca'],
        'creación': 2006,
        'caducidad': None,
    },
    'loglen': {
        'título': 'Lógica y lenguajes (trabajo de la universidad)',
        'título_corto_en_menú': 'Lógica y lenguajes',
        'título_extra_menú': 'Trabajo sobre sistemas lógicos e idiomas naturales y artificiales.',
        'ruta': 'apuntes/ales/hl/',
        'importancia': 2,
        'tema': 'lengualógica',
        'idiomas': ['es', 'ca'],
        'creación': 2006,
        'caducidad': None,
    },
    'asai_hh': {
        'título': 'Herman Hollerith y la máquina tabuladora (trabajo de la universidad)',
        'ruta': 'apuntes/asai/hh.html',
        'importancia': 1,
        'tema': 'aparatos',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'asai_tw': {
        'título': 'Thomas Watson e IBM (trabajo de la universidad)',
        'ruta': 'apuntes/asai/tw.html',
        'importancia': 1,
        'tema': 'aparatos',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'asai_catb': {
        'título': 'La catedral y el bazar (trabajo de la universidad)',
        'ruta': 'apuntes/asai/recensio/catb.html',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['ca'],
        'creación': 2006,
        'caducidad': None,
    },
    'asai_web': {
        'título': 'Tejiendo la web (trabajo de la universidad)',
        'ruta': 'apuntes/asai/recensio/red.html',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['ca'],
        'creación': 2006,
        'caducidad': None,
    },
    'placa_pi': {
        'título': 'Placa EZ-USB en Linux con SDCC',
        'ruta': 'placa_pi/',
        'importancia': 1,
        'tema': 'aparatos',
        'idiomas': ['es', 'en'],
        'creación': 2005,
        'caducidad': None,
    },
    'contacto': {
        'título': 'Contáctame',
        'título_corto_en_menú': 'Contáctame',
        'título_extra_menú': 'Por si quieres escribirme…',
        'ruta': 'contacto/',
        'importancia': 2,
        'tema': 'personal',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': None,
    },
    'cv': {
        'título': 'Mi currículum vitae',
        'título_corto_en_menú': 'Mi currículum',
        'título_extra_menú': 'Poca cosa',
        'ruta': 'cv/',
        'importancia': 3,
        'tema': 'personal',
        'idiomas': ['es', 'en'],
        'creación': 2001,
        'caducidad': None,
    },
    'cambios': {
        'título': 'Historial de cambios',
        'título_corto_en_menú': 'Historial',
        'título_extra_menú': 'Todos los cambios que le he ido haciendo a mi web',
        'ruta': 'cambios/',
        'importancia': 1,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': None,
    },
    'est': {
        'título': 'Estadísticas',
        'título_corto_en_menú': 'Estadísticas',
        'título_extra_menú': 'Gráficas generadas por awstats diariamente',
        'ruta': 'est/',
        'importancia': 1,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2002,
        'caducidad': None,
    },
    'portada': {
        'título': 'Portada',
        'ruta': '/',  # podría usar '' pero no quiero nulos
        'importancia': 1,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': None,
    },
    'mapaweb': {
        'título': 'Mapa de mi web',
        'título_corto_en_menú': 'Mapa de la web',
        'título_extra_menú': 'Datos avanzados de cada sección; interactivo',
        'ruta': 'mapa/',
        'importancia': 1,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2016,
        'caducidad': None,
    },
    'consumo': {
        'título': 'Cuánto gasta un ordenador',
        'título_corto_en_menú': '¿Cuánto gasta un ordenador?',
        'título_extra_menú': 'Aquí intento exlicar cómo medir el consumo de un aparato eléctrico.',
        'ruta': 'consumo/',
        'importancia': 2,
        'tema': 'aparatos',
        'idiomas': ['es', 'eo'],
        'creación': 2005,
        'caducidad': None,
    },
    'ruido': {
        'título': 'El ruido de mis monitores',
        'título_corto_en_menú': 'El ruido de mis monitores',
        'título_extra_menú': 'Un problema que tengo con todos mis aparatos de casa.',
        'ruta': 'ruido/',
        'importancia': 2,
        'tema': 'aparatos',
        'idiomas': ['es', 'en'],
        'creación': 2005,
        'caducidad': None,
    },
    # no pongo lo de „formato ogm“
        'manualmedidor': {
            'título': 'Manual de un medidor de corriente',
            'ruta': 'consumo/manual/',
            'importancia': 1,
            'tema': 'aparatos',
            'idiomas': ['ca', 'de', 'en', 'es', 'eo', 'it'],
            'creación': 2008,
            'caducidad': None,
        },
    'pc-tv': {
        'título': 'Conectar PC a TV',
        'título_corto_en_menú': 'Conectar el PC a la TV',
        'título_extra_menú': 'Cómo usar una televisión como si fuera una pantalla del ordenador.',
        'ruta': 'pc-tv/',
        'importancia': 1,
        'tema': 'aparatos',
        'idiomas': ['es', 'eo'],
        'creación': 2005,
        'caducidad': None,
    },
    'disk': {
        'título': 'Sistemas de discusión (mi tesis)',
        'título_corto_en_menú': 'Sistemas de discusión',
        'título_extra_menú': 'Mi proyecto final de carrera, sobre argumentación mediante el ordenador.',
        'ruta': 'disk/',
        'importancia': 1,
        'tema': 'lengualógica',
        'idiomas': ['es', 'ca', 'de', 'eo', 'en'],
        'creación': 2007,
        'caducidad': 2010,
    },
    'dislines': {
        'título': 'dislines (distribuir variantes de líneas hacia varios ficheros)',
        'título_corto_en_menú': 'dislines',
        'título_extra_menú': 'Script en Perl para traducir documentos de texto',
        'ruta': 'dislines/',
        'importancia': 2,
        'tema': 'programas',
        'idiomas': ['es', 'ca', 'eo', 'en'],
        'creación': 2005,
        'caducidad': None,
    },
    'muse-orgD0': {
        'título': 'Convertidor de sintaxis muse a org-mode (emacs)',
        'ruta': 'emacs/muse-orgD0.el',
        'importancia': 1,  # por no decir 0
        'tema': 'programas',
        'idiomas': ['en'],
        'creación': 2008,
        'caducidad': 2010,
    },
    'confi-emacs': {
        'título': 'Mi configuración de Emacs, y otros ficheros Lisp',
        'título_corto_en_menú': 'Mi .emacs',
        'título_extra_menú': 'Mi configuración de GNU Emacs, y otros programas en Lisp',
        'ruta': 'emacs/confi.html',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2020,
        'caducidad': None,
    },
    'erasmus': {
        'título': 'Papeleo para irse de Erasmus (a Alemania)',
        'título_corto_en_menú': 'Viaje de Erasmus',
        'título_extra_menú': 'Gestiones que hay que hacer para viajar al extranjero',
        'ruta': 'erasmus/',
        'importancia': 2,
        'tema': 'personal',  # ¿o viajes?
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'errores': {
        'título': 'Colección de errores de Windows con pantallazos',
        'título_corto_en_menú': 'Errores de Windows',
        'título_extra_menú': 'Llevo tiempo capturando fallos de programas',
        'ruta': 'errores/',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': None,
    },
    'reglas4p': {
        'título': '4 páginas de esperanto (gramática completa)',
        'título_corto_en_menú': 'Esperanto en 4 pág.',
        'título_extra_menú': 'Todas las reglas del idioma internacional esperanto',
        'ruta': 'esperanto/4p/',
        'importancia': 3,
        'tema': 'lengualógica',
        'idiomas': ['es', 'id'],
        'creación': 2014,
        'caducidad': None,
    },
    'eo-donis': {
        'título': 'Cómo el esperanto ha aportado a mi vida',
        'ruta': 'esperanto/donis.html',
        'importancia': 3,
        'tema': 'lengualógica',
        'idiomas': ['en'],
        'creación': 2017,
        'caducidad': None,
    },
    'hacer': {
        'título': 'Mi lista de cosas por hacer (anticuada, por reexportar)',
        'título_corto_en_menú': 'Cosas por hacer',
        'título_extra_menú': 'Ideas, críticas, y temas que quiero investigar',
        'ruta': 'hacer/',
        'importancia': 1,
        'tema': 'personal',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': 2012,
    },
    'org-mode': {
        'título': 'Cómo gestiono mis tareas y notas con org-mode (emacs)',
        'ruta': 'hacer/org.html',
        'importancia': 2,
        'tema': 'personal',
        'idiomas': ['es'],
        'creación': 2006,
        'caducidad': None,
    },
    'html-align': {
        'título': 'Alineación en HTML y CSS',
        'ruta': 'html/align/',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['en'],
        'creación': 2005,
        'caducidad': 2007,
    },
    'html': {
        'título': 'Cómo hacer buenas páginas web (HTML correcto)',
        'título_corto_en_menú': 'HTML correcto',
        'título_extra_menú': 'Cómo hacer buenas páginas web',
        'ruta': 'html/',
        'importancia': 2,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2004,
        'caducidad': 2014,
    },
    'mediospx': {
        'título': 'Medios píxeles en CSS',
        'ruta': 'html/medios_px/',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2008,
        'caducidad': None,
    },
    'teclado': {
        'título': 'Dibujo de teclados por HTML/CSS',
        'ruta': 'teclado/dibuja.html',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2005,
        'caducidad': None,
    },
    'sl': {
        'título': 'Software libre: tecnología que respeta a usuarios',
        'título_corto_en_menú': 'Respeto a usuarios (SL)',
        'título_extra_menú': 'Software libre: tecnología que respeta a usuarios. Qué es',
        'ruta': 'libera/sl.html',
        'importancia': 3,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2016,
        'caducidad': None,
    },
    'libro': {
        'título': 'Libro de visitas',
        'título_corto_en_menú': 'Libro de visitas',
        'título_extra_menú': 'Puedes dejar comentarios públicos y ver lo que me dicen',
        'ruta': 'libro/',
        'importancia': 1,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': None,
    },
    'bungku': {
        'título': 'Bahasa Bungku: diccionario y pequeña gramática',
        'ruta': 'lingvoj/bungku.html',
        'importancia': 2,
        'tema': 'lengualógica',
        'idiomas': ['id'],
        'creación': 2015,
        'caducidad': None,
    },
    'koroni': {
        'título': 'Bahasa Koroni: muestra de diálogo',
        'ruta': 'lingvoj/koroni.html',
        'importancia': 1,
        'tema': 'lengualógica',
        'idiomas': ['id'],
        'creación': 2015,
        'caducidad': None,
    },
    'parches-l2h': {
        'título': 'Parches viejos para latex2html',
        'ruta': 'linux/l2h.html',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['en'],
        'creación': 2005,
        'caducidad': 2010,
    },
    'trucoslinux': {
        'título': 'Trucos sueltos para Linux',
        'ruta': 'linux/trucos.html',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2005,
        'caducidad': None,
    },
    'trucoswindows': {
        'título': 'Trucos sueltos para Windows (antiguo)',
        'ruta': 'trucos/',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': 2005,
    },
    'vb': {
        'título': 'Visual Basic (antiguo)',
        'ruta': 'vb/',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': 2008,
    },
    'dhtml': {
        'título': 'Transiciones DHTML (antiguo)',
        'ruta': 'dhtml/',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2001,
        'caducidad': 2004,
    },
    'webch': {
        'título': '„Web characters“ (programa para reemplazar letras en HTML)',
        'título_corto_en_menú': 'Web Characters',
        'título_extra_menú': 'Haz que en otros países vean los acentos de tus páginas',
        'ruta': 'webch/',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2003,
        'caducidad': 2007,
    },
    'schart': {
        'título': 'Generador de tabla de transposicionales en patrones malabares',
        'ruta': 'linux/schart.html',
        'importancia': 1,
        'tema': 'programas',
        'idiomas': ['en', 'es'],
        'creación': 2005,
        'caducidad': None,
    },
    'dn': {
        'título': 'Deducción natural',
        'título_corto_en_menú': 'Deducción natural',
        'título_extra_menú': 'Tutorial de lógica. Sirve para pensar mejor.',
        # No sé qué ruta poner. dn.html es versión en español.
        # Pero me gusta a veces enlazar a la lista de idiomas
        # 'ruta': 'logica/dn.html',
        'ruta': 'logica/',
        'importancia': 2,
        'tema': 'lengualógica',
        'idiomas': ['en', 'es', 'ca', 'eo'],
        'creación': 2004,
        'caducidad': None,
    },
    'ingenio': {
        'título': 'Juegos de ingenio',
        'título_corto_en_menú': 'Juegos de lógica',
        'título_extra_menú': 'Problemas de ingenio. Matemagia. Bueno, sólo puse 1',
        'ruta': 'logica/juegos.html',
        'importancia': 2,
        'tema': 'lengualógica',
        'idiomas': ['es'],
        'creación': 2017,
        'caducidad': None,
    },
    'vortoj-logikaj': {
        'título': 'Terminología de lógica en esperanto',
        'ruta': 'logica/vortoj.html',
        'importancia': 1,
        'tema': 'lengualógica',
        'idiomas': ['eo'],
        'creación': 2005,
        'caducidad': None,
    },
    'vortoj-elektraj': {
        'título': 'Terminología de electrotecnia en esperanto',
        'ruta': 'consumo/vortoj.html',
        'importancia': 1,
        'tema': 'lengualógica',
        'idiomas': ['eo'],
        'creación': 2005,
        'caducidad': None,
    },
    'vortoj-kataluna': {
        'título': 'Unas cuantas notas de catalán',
        'ruta': 'lingvoj/apuntscat.html',
        'importancia': 1,
        'tema': 'lengualógica',
        'idiomas': ['ca'],
        'creación': 2005,
        'caducidad': None,
    },
    'eraroj-kataluna': {
        'título': 'Evitar errores comunes en catalán hablado',
        'ruta': 'lingvoj/errorscat.html',
        'importancia': 2,
        'tema': 'lengualógica',
        'idiomas': ['ca'],
        'creación': 2017,
        'caducidad': None,
    },
    'popup-ie': {
        'título': '¿Aún usas Internet Explorer?',
        'título_corto_en_menú': 'Popup para IE',
        'título_extra_menú': 'Mensaje que sale a quien entre usando Internet Explorer',
        'ruta': 'navega/popup.html',
        'importancia': 2,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2004,
        'caducidad': 2010,
    },
    'genpopup-ie': {
        'título': 'Generador de popup para artículo „¿Aún usas Internet Explorer?“',
        'ruta': 'navega/ponlo.html',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['es'],
        'creación': 2004,
        'caducidad': 2010,
    },
    'id-coinbase': {
        'título': 'Coinbase, Authy, and sending your ID to strangers',
        'ruta': 'seguridad/coinbase-id.html',
        'importancia': 1,
        'tema': 'www',
        'idiomas': ['en'],
        'creación': 2017,
        'caducidad': None,
    },
    'estado-actual': {
        'título': 'Mi estado actual / todobien.png',
        'título_corto_en_menú': 'Mi estado actual',
        'título_extra_menú': 'Mi respuesta a ¿qué tal?',
        'ruta': '/index.html#estado-actual',
        'importancia': 2,
        'tema': 'personal',
        'idiomas': ['es'],
        'creación': 2020,
        'caducidad': None,
    },
    'hiper': {
        'título': 'Sistema de hipertexto y publicación en mi web',
        'título_corto_en_menú': 'Hipertexto y publicación',
        'título_extra_menú': 'Cómo organizo y exporto la información',
        'ruta': 'hiper/',
        'importancia': 3,
        'tema': 'mi_web',
        'idiomas': ['es'],
        'creación': 2023,
        'caducidad': None,
    },
    'bufonería': {
        'título': 'Bufonería',
        'ruta': 'index.html#bufonería',
        'importancia': 1,
        'tema': 'personal',
        'idiomas': ['es'],
        'creación': 2024,
        'caducidad': None,
    },
}

# Parecido a LISTA_DE_SECCIONES_YA_ESCRITAS, Pero aquí registro secciones „virtuales“ que no tienen contenido
# sino que describen una pequeña lista de otras secciones ya en LISTA_DE_SECCIONES_YA_ESCRITAS, que eran
# demasiado pequeñas para aparecer por sí solas.
# Sin embargo, un grupo de secciones (Gruse) sí que tiene una URL
# En el 'incluye secciones' anoto las secciones de LISTA_DE_SECCIONES_YA_ESCRITAS metidas dentro de cada Gruse;
# se me ocurren formas de usar eso (ẽ para validar estructura, o añadir 3r nivel al menú) pero no lo implemento
# pues no me hace falta; por eso comento ese dato.
GRUPOS_DE_SECCIONES = {
    'notas-html-y-css': {
        'título_corto_en_menú': 'Notas de HTML y CSS',
        'título_extra_menú': 'Detalles sobre cosas raras en HTML y CSS',
        'ruta': '/index.html#notas_html',
        # ¿Los otros atributos me hacen falta? De momento no los pondré
        # 'título': '',  # ← ¿dónde lo uso?
        # 'incluye secciones': ['mediospx', 'teclado', 'html-align'],
    },
    'apuntes-de-idiomas': {
        'título_corto_en_menú': 'Apuntes de idiomas',
        'título_extra_menú': 'Pequeñas gramáticas, tesauros y muestras de idiomas.',
        'ruta': '/index.html#apuntes_idiomas',
        # 'incluye secciones': ['eo-donis', 'vortoj-kataluna', 'eraroj-kataluna', 'vortoj-logikaj', 'vortoj-elektraj', 'bungku', 'koroni'],
    },
    'parches-linux': {
        'título_corto_en_menú': 'Parches',
        'título_extra_menú': 'Cosas sobre Linux y mejoras a otros programas; no muy interesante.',
        'ruta': '/linux/',
        # 'incluye secciones': ['trucoslinux', 'parches-l2h', 'muse-orgD0'],  # no apunto txt2tags pues es poco
     },
    'scripts-de-mi-web': {
        'título_corto_en_menú': 'Scripts de mi web',
        'título_extra_menú': 'Programitas cortos que he creado por necesidades con mi web',
        'ruta': '/scripts/',
        # 'incluye secciones': [],  # Ninguna en concreto. Lo de dentro es muy granular
    },
    'secciones-antiguas': {
        'título_corto_en_menú': 'Secciones antiguas',
        'título_extra_menú': 'Secciones mal hechas y que no me gustan mucho, pero que me da pena quitar',
        'ruta': '/index.html#ant',
        # 'incluye secciones': ['trucoswindows', 'vb', 'dhtml'],
    },
}

# en esta fecha puse todas las secciones. „Revisado hasta“, „actual hasta fecha“, „actualizado por última vez“
COMPLETO_HASTA_FECHA = datetime(2024, 6, 28)

# Estas variables son opcionales, las uso internamente. Creo que no es información para otros. Rectifícame si hace falta
MOSTRAR_TAMBIÉN_LA_RUTA_EN_TABLA = False
MOSTRAR_TAMBIÉN_GRADO_DE_DEFINICIÓN = False
AÑADE_NO_PUBLICADAS = False
MOSTRAR_ESTADOS = False
# ver abajo: AÑADE_NO_PUBLICADAS = True

# Por la inflación, ahora valen menos
# Le pongo este número para que secciones sin texto (ej. estadísticas) no queden enanas (ej. tamaño 0 ó 1)
UNA_IMAGEN_VALE_CUÁNTAS_PALABRAS = 100

# Esto es el modo de pruebas, y lo uso en local, sin publicarlo
if 0:
    MOSTRAR_TAMBIÉN_LA_RUTA_EN_TABLA = True
    MOSTRAR_TAMBIÉN_GRADO_DE_DEFINICIÓN = True
    AÑADE_NO_PUBLICADAS = True
    MOSTRAR_ESTADOS = True


def comprueba_estructura(secciones):
    """
    Comprueba que he escrito a mano bien los datos. Para si no.
    """
    for s, dat in secciones.items():
        assert dat['título']
        assert dat['ruta']
        assert dat['importancia'] in [1, 2, 3]
        assert dat['tema']
        assert dat['tema'] in TEMAS
        assert dat['idiomas']
        assert all([i in IDIOMAS for i in dat['idiomas']])
        # Quizás no todos aparecerán en el menú. Algunos que son muy detallados no aparecen. Por eso comento:
        # assert dat['título_corto_en_menú']
        # assert dat['título_extra_menú']
        # Pero sí que miro esto ya:
        # ẽ "¿Cuánto gasta un ordenador?" es de los más largos y tiene 29 letras
        if 'título_corto_en_menú' in dat:
            assert len(dat['título_corto_en_menú']) < 30


def añade_info_de_tamaño(secciones):
    "A cada artículo le añade el cuántas palabras son"
    for s, dat in secciones.items():
        print(s, dat['ruta'])
        # detectar qué fichero abrir
        # este if es por formatos
        if s == 'loglen':  # PS
            # atención, el formato PS da algunos problemas…
            # ¡muchos! Ver notas. „pstotext“ con un fichero vacío ya peta de formas raras
            #      echo > algo.ps; pstotext -debug algo.ps
            # Error: /invalidaccess in --def--
            # com = "zcat /home/dc/repoweb/apuntes/ales/hl/hl.es.ps.gz | pstotext | wc -w"
            #
            # esquive:
            # com = "echo 15171"
            # pero mejor lo reimplemento leyendo el HTML, da un contaje parecido (15k)
            # Atención, hay bastantes guarradillas ad-hoc aquí. Si esto te ofende, no lo mires
            com = """bash -c "source /home/dc/ut/root/etc%bash.utisdc; cat /home/dc/repoweb/apuntes/ales/hl/html/hl.es*.xhtml | tr '\\n' ' ' | perl -pe 's|<!--Navigation Panel-->.*?<!--End of Navigation Panel-->|<!-- -->|g;' |  filtro_quita_etiquetas_xml | sed 's/ \\.\\+ //g; s/ \\.\\+ //g; s/-->//g; s/<!--//g; s/&nbsp;//g;'  | wc -w"; """
        elif s == 'disk':  # PDF es mejor
            com = "pdftotext  /home/dc/repoweb/disk/disk.de.pdf - | wc -w"
        elif s == 'dn':  # PDF
            com = "pdftotext  /home/dc/repoweb/logica/dn.pdf - | wc -w"
        elif dat['ruta'].endswith('.el'):  # .el, más fácil contar palabras
            com = "cat /home/dc/repoweb/%s | wc -w" % dat['ruta']
        elif s == 'errores':  # tomo otro fichero equivalente a todos los mensajes
            com = "cat /home/dc/repoweb/errores/viejo/errores.js | wc -w"
        elif s == 'hacer':  # he de combinar varios ficheros
            # tomo los org aunque incluyan opciones.org etc.
            com = "cat /home/dc/repoweb/hacer/*.org | wc -w"
        elif s == 'est':
            # no sé qué decir. Para que al menos salga en gráficos, pongo un valor pequeño
            com = "echo %i" % UNA_IMAGEN_VALE_CUÁNTAS_PALABRAS
        elif s == 'estado-actual':
            # Por ahora es exactamente imagen
            com = "echo %i" % UNA_IMAGEN_VALE_CUÁNTAS_PALABRAS
        elif s == 'bufonería':
            # mmm… hay que actualizar el refrán para que aplique a vídeos cortos
            com = "echo %i" % UNA_IMAGEN_VALE_CUÁNTAS_PALABRAS
        else:
            # resto. Intuyo que son HTML. Contables con wc
            dónde = None
            # if s=='ataque':
            #    dónde = 'ataque/index.html'
            # elif s=='trucoswindows':
            #    dónde = 'ataque/index.html'
            if dat['ruta'].endswith('html'):  # directo
                dónde = dat['ruta']
            elif s in ['consumo', 'pc-tv', 'ruido', 'ataque', 'barrapunto', 'apuntes', 'dhtml', 'portada', 'mediospx', 'amarok', 'mapaweb', ]:  # sólo me dejé ponerle el /index.html
                dónde = dat['ruta']+'index.html'
            elif s == 'cambios':  # como añadir index.html, pero añadiendo otra cosa
                dónde = dat['ruta']+'todos.html'
            elif s in ['placa_pi', 'dislines', 'manualmedidor']:  # ídem
                dónde = dat['ruta']+'index.es.html'
            elif s == 'reglas4p':  # ídem
                dónde = dat['ruta']+'reglas4p.html'
            elif s == 'servidor':  # ídem
                dónde = dat['ruta']+'TRcast.html'
            elif s == 'html':  # ídem
                dónde = dat['ruta']+'junto.html'
            elif s == 'libro':
                # v1: Ignoro la portadita, me fijo sólo en la parte gorda
                # dónde = dat['ruta']+'archivo.html'
                # v2: el contenido del libro no es mío, no lo escribí yo. Ya que estoy haciendo mapa de mi web, ignoro
                # toda esa parte (siempre fue externa) y sólo mido la portadita
                dónde = dat['ruta']+'index.html'
            elif dat['ruta'].endswith('/'):
                los_html = [f for f in os.listdir('/home/dc/repoweb/%s' % dat['ruta']) if f.endswith('.html')]
                if len(los_html) == 1:
                    dónde = dat['ruta']+los_html[0]
                    # print("Tomando %s como fuente (detectado por fichero único) para contar palabras. Entra"%dónde); raw_input()
                else:
                    raise NotImplementedError(los_html)
            else:
                raise NotImplementedError(dat['ruta'])
            assert dónde
            # import ipdb;ipdb.set_trace()
            com = 'bash -c "source /home/dc/ut/root/etc%%bash.utisdc; cat /home/dc/repoweb/%s | filtro_quita_etiquetas_xml | wc -w"' % dónde
        assert com
        print(": Com:; ", com)
        com = os.popen(com, 'r')
        rec = com.readline()
        cuántas_pal = int(rec)
        com.close()
        print("Pal:", cuántas_pal)

        if s == 'mapaweb' and cuántas_pal == 0:
            print("Atención, mapaweb tiene contaje 0, eso es que no existía. Corre el programa otra vez para que se"
                  " cuenten bien las palabras")
            print("Aprieta entrar")
            input()
        else:
            assert cuántas_pal > 0

        secciones[s]['palabras'] = cuántas_pal
    return secciones


def genera_mapa_html(secciones):
    """
    Escribe el HTML en mi web, con cabeceras etc. y con la tabla con datos de las secciones.
    """
    print("Escribiendo HTML")
    fi = open("/home/dc/repoweb/mapa/index.html", "w")
    fi.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="es">
<head>
<title>Mapa de mi web. Secciones de danielclemente.com</title>
<meta name="generator" content="https://www.danielclemente.com/scripts/estruweb.py"><!-- código feo… -->
<meta content="text/html; charset=utf-8" http-equiv="content-type">
<link rel="stylesheet" type="text/css" href="../menu/menu.css">
<script type="text/javascript" src="../pagina/jquery-2.2.0.min.js"></script>
<script type="text/javascript" src="../pagina/jquery.inc.js"></script>
<script type="text/javascript" src="../menu/menu-v2.js"></script>
<!-- de http://tablesorter.com/docs/ , https://github.com/christianbach/tablesorter -->
<script type="text/javascript" src="../pagina/jquery.tablesorter.min.js"></script>

<!-- gráfico de secciones, con bolas arrastrables -->
<!-- <script src="http://d3js.org/d3.v3.min.js"></script> -->
<!-- creo que dejó de ir cuando usé https, pues desde https el navegador no quiere cargar http.
Mejor lo alojo yo (para evitar la ejecución de código arbitrario de terceros): -->
<script src="../pagina/d3.v3.min.js"></script>
<script src="grafisecc.js"></script>

<script type="text/javascript">
$(document).ready(function() {
        // lo mantengo ordenado por „importancia“ (más a menos) e índice secundario „núm. palabras“ (más a menos)
        $("#mapaweb").tablesorter({sortList: [[0,1], [10,1]]});
        //alert('bien');
        //console.log('bien');
    }
);

function expandir_contraido(id_el){
    // casualmente sin jquery
    el=document.getElementById(id_el); el.style.display="block";
}
</script>
<style type="text/css">
body {margin:4%%;}
h1 {text-align: center;margin-bottom: 1em; }
table#mapaweb th {
    background: #ed2;
    cursor: pointer;
}
table#mapaweb th:hover {background: #dc1;}
table#mapaweb {
    border-spacing:0;
    border: 1px solid black;
    border-collapse: collapse;
}
table#mapaweb td {
    border:1px solid #3af;
    padding:5px;
}
table#mapaweb tbody tr:hover {
    background: #dde;
}

%(ESTILOS_SOBRE_ESTADOS)s

</style>
</head>
<body>

<h1>Mapa de secciones de mi web</h1>

<p>
    Puedes jugar con estas bolitas arrastrables. El tamaño corresponde con la longitud de cada sección.
    Están agrupadas por temas. Los colores pálidos representan secciones anticuadas.
    Las de borde negro son las que personalmente destaco.
    Para ir a una sección haz clic en el nodo y luego en el enlace en esquina ┌ (o busca el enlace en la tabla).
</p>

<div id="grafisecc"></div>

<p>
Aquí están los mismo datos en forma de tabla. Puedes <strong>ordenarla</strong> clicando cada cabecera.
<a href="javascript:expandir_contraido('explicacols');">Explicaciones sobre columnas ▾</a>.
</p>

<ul id="explicacols" style="display:none">
<li>
    Lo de <strong>importancia</strong> es subjetivo.
    No lo sé justificar bien; es algo así como „no te vayas de mi web sin ver esto“
    o „si me has de juzgar por algo, que sea por esto“. Si hay artículos buenos marcados con poca importancia quizás es
    por demasiada humildad. Avísame si crees que alguna sección es más útil y debería tener más peso.
</li>
<li>
    El <strong>nº de palabras</strong> está computado automáticamente y en algunos casos (con PDF)
    es algo más alto de la cuenta debido a programas que no entienden UTF-8 bien. No tiene en cuenta imágenes.
</li>
<li>
    La <strong>caducidad</strong> también es subjetiva. La pongo en cosas que son de hace tiempo,
    para decir „habría que actualizarlo pues ya no es útil“. Hay otras cosas que no pierden utilidad con el tiempo,
    otras que caducarán pero en unos años más, y otras que aunque caducarán no actualizaré porque son
    historias inmutables sobre algo pasado.
</li>
<li>
    Escríbeme si quieres que añada o simplifique datos. O añadir otras vistas. O cambiar estilos/iconos/etc.
    Recuerda clicar sobre cabeceras de la tabla para encontrar lo que buscas.
</li>
</ul>

<p>Grafo pelotudo y tabla revisados manualmente por última vez el %(actual_hasta)s. Y todo generado el %(fecha_act)s.
<a href="https://www.danielclemente.com/">https://www.danielclemente.com/</a>
(<a href="https://www.danielclemente.com/contacto/">contacto</a>).
</p>


<table id="mapaweb" class="tablesorter">
<thead>
<tr>
<th>Importancia</th>
<!-- Grado de definición: -->%(th_para_grado_de_definición)s
<th>Sección</th>
<!-- Ruta: -->%(th_para_ruta)s
<th>Tema</th>
<!-- Idiomas: -->%(th_para_cada_idioma)s
<th>nº palabras</th>
<th>Creación</th>
<th>Caducidad</th>
</tr>
</thead>
<tbody>
""" % {
        'actual_hasta': COMPLETO_HASTA_FECHA.strftime("%d.m%m.%Y").lstrip("0"),
        'fecha_act': datetime.now().strftime("%d.m%m.%Y").lstrip("0"),
        'th_para_cada_idioma': "".join(['<th>%s</th>' % i for i in IDIOMAS]),
        'th_para_ruta': "<th>Ruta</th>" if MOSTRAR_TAMBIÉN_LA_RUTA_EN_TABLA else "",
        'th_para_grado_de_definición': "<th>Grado de definición</th>" if MOSTRAR_TAMBIÉN_GRADO_DE_DEFINICIÓN else "",
        'ESTILOS_SOBRE_ESTADOS': """
#mapaweb .inédito td {background: #ffaaaa;}
#mapaweb .caducado td {text-decoration: line-through;}
#mapaweb .importante td {font-weight: bold;}
        """ if MOSTRAR_ESTADOS else "",
    })
    # Nota: aquí recorro la lista de *secciones*. Esto no incluye los „grupos de secciones“ (Gruse)
    # No los incluyo pues no tienen contenido, y sus pequeños componentes ya están incluidos en la
    # lista de secciones
    for s in sorted(secciones.keys(), key=lambda se: secciones[se]['importancia'], reverse=True):
        dat = secciones[s]
        estados = []
        if not dat['creación']:
            estados.append("inédito")
        if dat['importancia'] >= 3:
            estados.append("importante")
        if dat['caducidad'] and dat['caducidad'] <= 2020:
            estados.append("caducado")
        print(dat, estados)
        # Código complejito
        # Implícitamente digo que lo ya publicado no tiene/necesita grado de definición
        # Implícitamente digo que lo no publicado requiere tener entrada „grado de definición“ (aunque sea None)
        # Explícitamente digo que si es None entonces usaré 0 estrellitas
        grado_de_definición_a_mostrar = 0 if "inédito" not in estados else (dat['grado_de_definición'] or 0)
        # print("%i: %s"%(dat['importancia'],s))
        fi.write("""
<tr class="%(estado)s">
<td>%(impo)s</td>
<!-- Grado de definición: -->%(td_para_grado_de_definición)s
<td><a href="%(ruta)s">%(secc)s</a></td>
<!-- Ruta: -->%(td_para_ruta)s
<td>%(tema)s</td>
<!-- Idiomas: -->%(td_para_cada_idioma_usado)s
<td>%(númpals)s</td>
<td>%(creación)s</td>
<td>%(caduc)s</td>
</tr>
""" % {
    'impo': '(*)' * dat['importancia'],
    'secc': dat['título'],
    'ruta': '../'+dat['ruta'],
    'tema': dat['tema'],
    # 'idiomas': ",".join(dat['idiomas']),
    'td_para_cada_idioma_usado': "".join([
        "<td>%s</td>" % (i.upper() if i in dat['idiomas'] else "") for i in IDIOMAS
    ]),
    'td_para_grado_de_definición': "<td>%s</td>" % ('(*)' * grado_de_definición_a_mostrar) if MOSTRAR_TAMBIÉN_GRADO_DE_DEFINICIÓN else "",
    'td_para_ruta': "<td>%s</td>" % dat['ruta'] if MOSTRAR_TAMBIÉN_LA_RUTA_EN_TABLA else "",
    'creación': dat['creación'] or "",
    'caduc': dat['caducidad'] or "",
    'númpals': dat.get('palabras', '---'),  # por si está desact.
    'estado': " ".join(estados),
    })
    fi.write("""
</tbody>
</table>
</body>
</html>
""")
    fi.close()


def genera_ficheros_de_menú(secciones):
    """
    Escribe el JS de menubody.js y menu-v2.html, automáticamente.
    Antes de esto, lo actualizaba a mano en ambos sitios.
    Todo esto de meter código HTML y JS es cutre, pero es un pequeño paso respecto a la versión anterior.
    Lo siguiente será usar plantillas (jinja2, …) o hacerme un CRM (o encontrar uno bueno).
    """
    class Gruse(str):
        """
        Grupo de secciones. Describe una „sección virtual“, que engloba varias secciones pero que tiene identidad
        propia y por eso quiero darle un nombre y un texto descriptivo y URL. En ciertos sitios (ẽ menú) puedo
        apuntar a un gruse en vez de a cada uno de sus contenidos.
        Lo iba a llamar agrupección (agrupación de secciones) pero „gruse“ es más corto.
        Y quizás en el futuro uso esto para *todo* (pues todo se puede ver como conteniendo más información…).
        Ver GRUPOS_DE_SECCIONES para más datos.
        Esta clase sólo etiqueta la cadena; le da un tipo. Pero el código ya ha de saber extraer datos
        de GRUPOS_DE_SECCIONES; no quiero añadir capas.
        """
        pass

    # primer intento de formalización
    ÍNDICE_EN_MENÚ = OrderedDict([
        ('Servidores', ['servidor', 'amarok', 'amarok-resulta', 'barrapunto', 'ataque']),
        ('Internet', ['popup-ie', 'html', Gruse('notas-html-y-css')]),
        ('LenguaLógica', ['dn', 'reglas4p', Gruse('apuntes-de-idiomas'), 'loglen', 'disk', 'ingenio']),
        ('Aparatos', ['ruido', 'consumo', 'pc-tv']),
        ('Programas', ['sl', 'dislines', 'confi-emacs', 'webch', 'errores', Gruse('parches-linux')]),
        ('Yo', ['cv', 'hacer', '142857', 'erasmus', 'contacto', 'apuntes', 'estado-actual']),
        ('Página', ['cambios', 'mapaweb', 'hiper', 'libro', Gruse('scripts-de-mi-web'), Gruse('secciones-antiguas'), 'est']),
    ])
    # Más adelante querré también formalizar el índice de mi portada, y ofrecer varios índices automáticamente

    #
    # MENU-V2.HTML (el v2)
    #

    print("Escribiendo menu-v2.html")
    cadena_con_secciones_y_subsecciones = "\n"
    for (nombre_sección, subsecciones) in ÍNDICE_EN_MENÚ.items():
        cadena_con_secciones_y_subsecciones += """<li class="sub"><a>%s</a>\n""" % nombre_sección
        cadena_con_secciones_y_subsecciones += """<ul>\n"""
        for id_sección in subsecciones:
            # Aquí podría hacer clases, y hacer objeto.obtén_datos() etc. pero no quiero más capas
            if not isinstance(id_sección, Gruse):
                datos_sección = secciones[id_sección]
            else:
                datos_sección = GRUPOS_DE_SECCIONES[id_sección]

            ruta_rel = datos_sección['ruta']
            nombre, title = datos_sección['título_corto_en_menú'], datos_sección['título_extra_menú']
            cadena_con_secciones_y_subsecciones += """  <li><a href="{href}" title="{title}">{nombre}</a></li>\n""".format(
                href="https://www.danielclemente.com/"+re.sub("^/", "", ruta_rel),
                title=title,
                nombre=nombre,
            )
        cadena_con_secciones_y_subsecciones += """</ul>\n"""
        cadena_con_secciones_y_subsecciones += """</li>\n"""

    fi = open("/home/dc/repoweb/menu/menu-v2.html", "w")
    fi.write("""
<!-- esto va dentro de un div#menu y se carga mediante menu-v2.js  -->
<!--
- m8.2009: aún está en pruebas
- m2.2022: ahora, este fichero SE AUTOGENERA a partir de estruweb.py. Por tanto NO HAY QUE AÑADIR AQUÍ, sino ejecutar estruweb.py. Tampoco hay que añadir a menubody.js (el v1)

¿Esto necesita un doctype? Hay entidades → Las quité y uso utf-8 directamente. Importante no ponerlas (si las pongo, los XHTML que incluyan este menú se quejarán)
 -->

<ul id="top">
<li class="sub"><a>menú</a>
<ul>

<li id="espaciador-menú">↓</li>
<li><a href="https://www.danielclemente.com/" title="Página principal">Índice</a></li>

{cadena_con_secciones_y_subsecciones}

</ul>
</li>
</ul>

""".format(cadena_con_secciones_y_subsecciones=cadena_con_secciones_y_subsecciones))
    fi.close()

    #
    # MENUBODY.JS (el v1)
    #

    print("Escribiendo menubody.js")
    fi = open("/home/dc/repoweb/menu/menubody.js", "w")
    líneas_html_a_escribir = []
    líneas_html_a_escribir += [
        """<div id="menu">""",
        """<ul id="top">""",
        """<li class="sub"><a>men&uacute;</a>""",
        """<ul>""",
        """<li id="espaciador-menú">↓</li>""",
        """<li><a href="https://www.danielclemente.com/" title="P&aacute;gina principal">&iacute;ndice</a></li>""",
    ]
    líneas_html_a_escribir += cadena_con_secciones_y_subsecciones.splitlines()
    líneas_html_a_escribir += [
        """</ul>""",
        """</li>""",
        """</ul>""",
        """</div>""",
    ]
    assert "'" not in cadena_con_secciones_y_subsecciones
    assert "'" not in "".join(líneas_html_a_escribir)

    fi.write("""

// - Abrir popup a los que usan navegadores no compatibles con los estándares de Internet
// - Escribir el HTML que luego será un bonito menú CSS
//
//  20 Agosto 2004   Daniel Clemente. Todo esto es GPL.
//            https://www.danielclemente.com
//
//  En 2022: veo que este código es muy malo. Ya lo reemplacé por el menú nuevo.
//  Por cierto, este fichero AHORA SE AUTOGENERA con estruweb.py
//  Así que no me hace falta editarlo a mano

// console.log("Esto es menubody.js (v1)");

var ua=navigator.userAgent;

// Notas:
// - Opera a veces se identifica como IE
// - IE para MacOS 9 no tiene tantos fallos, y no hay tantas alternativas

if( ua.indexOf("MSIE")!=-1 && ua.indexOf("Opera")==-1 && ua.indexOf("Mac") == -1 ) {
    window.open('../navega/popup.html','aviso','status=yes,scrollbars=yes,resizable=yes');
    document.writeln("<br><br><div style='border: 5px double blue; " +
                     "margin: 30px; padding: 20px; background: #f0f000; font-size: 23px; " +
                     " font-weight: bold; color: red;'>" +
                     "&nbsp;&nbsp;&nbsp;<u>Aviso</u>:" +
                     " usas Internet Explorer (uno de los peores navegadores)," +
                     " y eso perjudica a Internet. " +
                     "<a href='../navega/popup.html'>Te recomiendo otros</a>," +
                     " para que puedas ver las webs c&oacute;modamente y sin errores.</div><br><br><br><br>");
}


//
// Desde 10.m8.2009 evito usar este menú. Y uso /menu/menu-v2.js en las páginas nuevas
// Además, desde 8.m2.2022 no hace falta editar ninguno de ambos ficheros a mano, sino que se generan automáticamente por estruweb.py
//

document.writeln('%s'); // Menudo trozo...

// console.log("Fin de menubody.js (v1)");

""" % "\\\n".join(líneas_html_a_escribir))
    # Ahí arriba no puedo usar .format() porque el JS de dentro contiene {}

    # No añado todo lo de „estados“ (inédito/importante/caducado)

    fi.close()

    print("Generados menubody.js (el v1) y menu-v2.html (el nuevo), con contenido de estruweb.py")


def exporta_json(secciones):
    """JSON, útil para ej. http://app.rawgraphs.io/, o para gráfico de secciones"""
    print("Exportando JSON")
    # es como dict. Python pero sin None y sin comas finales
    with open('/home/dc/repoweb/pagina/seccionesweb.json', 'w') as fi:
        estru = []  # será primer elemento de JSON
        for s, dat in secciones.items():
            di = dict(dat)
            di['nombre'] = s
            estru.append(di)
        json.dump(estru, fi, indent=4, sort_keys=True)


def exporta_csv(secciones):
    """Crea fichero CSV."""
    print("Exportando CSV")
    raise NotImplementedError("CSV no es muy apropiado porque no me permite listas, y yo uso para guardar los idiomas. "
                              "Mejor usa JSON")

    # with open('/home/dc/n/seccionesweb.csv', 'w') as nomfi:
    #     fi = csv.writer(nomfi)
    #     for s, dat in secciones.items():
    #         print(dat.values())
    #         # fi.writerow
    # import ipdb; ipdb.set_trace()


def intuye_tema(línea_de_csv_de_datoscables):
    """
    A partir de datos de datoscables.csv (vienen de org), intenta intuir a qué tema de mi web correspondería.
    Ésta es la solución rápida que equivale a definir en cada sección de org la categoría a la que exportar.
    Devuelve None si no lo sabe
    """
    ruta = línea_de_csv_de_datoscables['fichex']
    if '/libera/' in ruta:
        # Mmmmmm… ética en tecnología, ¿va de software o no? Va de todo
        # tema = 'programas'
        tema = 'filosofía'
    elif '/privacidad/' in ruta:
        # difícil catalogar esto también
        tema = 'filosofía'
    elif '/seguridad/' in ruta:
        tema = 'programas'
    elif '/info/' in ruta:
        # informática
        tema = 'programas'
    elif '/html/' in ruta:
        tema = 'www'
    elif 'idiomas' in ruta:
        tema = 'lengualógica'
    elif 'lingvoj' in ruta:
        tema = 'lengualógica'
    elif 'esperanto' in ruta:
        tema = 'lengualógica'
    elif '/logica/' in ruta:
        tema = 'lengualógica'
    elif '/contacto/' in ruta:
        tema = 'personal'
    elif '/lerno/' in ruta:
        # aún no he publicado todo esto sobre aprendizaje…
        tema = 'personal'
    elif '/etiko/' in ruta:
        tema = 'filosofía'
    elif '/problemas/' in ruta:
        # Bueno, hay problemas de todo tipo…
        # Incluso podría ponerlo como categoría „personal“
        tema = 'filosofía'
    elif '/org/' in ruta:
        # organización del tiempo; infraestructura de conocimiento etc. son „programas“ (o sea forma escrituras de procesos)
        tema = 'programas'
    elif ruta.endswith('mouse.html'):
        tema = 'aparatos'
    else:
        tema = None
    # Pruebo a incluir propuestas de categorías
    # assert not tema or tema in TEMAS
    assert not tema or tema in TEMAS or tema in ['filosofía']
    return tema


def añade_secciones_aún_no_publicadas(secciones):
    """
    Añade a esta misma tabla (y grafo) todas las secciones que tengo a medio escribir y que no
    he publicado aún. Los „cables“, le llamo (publicable). Esta información viene de org-mode,
    donde hay cabeceras etiquetadas con „:cable:“, y luego me hice un prita en Lisp para extraer
    estas cabeceras y generar un .csv. Aquí lo asinto y lo incorporo.
    ¡Esta función sólo me interesa a mí! Por ahora no publico los cables (si lo hiciere serían cados…)
    """
    print("Voy a leer el datoscables.csv. Obviamente ha de estar actualizado (usa: „vercables“)")
    fi = open("/home/dc/.medidas/datoscables.csv", "r")
    lee = csv.DictReader(fi)
    for fi in lee:
        if fi['estado'] in ['I'+'S', 'M'+'ALFAR']:
            # Éstos ya están publicados. No debería haberlos metido en el CSV…
            continue
        id_art = fi['cat'] + fi['lín']
        ruta = re.sub("^(.*repoweb/)", "", fi['fichex'])
        título = fi['títex'] or "∅∅∅. Pero es la cabecera %s:%s «%s»" % (fi['cat'], fi['lín'], fi['texto'])
        palabras = int(fi['longitudbytes'])//8  # muy aprox. En realidad hay muchos metadatos
        tema_intuido = intuye_tema(fi) or 'ya veremos'
        secciones[id_art] = {
            'título': título,
            'ruta': ruta,
            'importancia': {"A": 3, "B": 2, "C": 1}[fi['prio']],
            'grado_de_definición': {"A": 3, "B": 2, "C": 1}[fi['gradodef']] if fi['gradodef'] else None,
            'tema': tema_intuido,
            'idiomas': ['sw'],
            'creación': None,
            'caducidad': None,
            'palabras': palabras,
        }

    # raise NotImplementedError("Por hacer: asintar el CSV que generé desde Lisp e incluirlas aquí")
    return secciones


#
# empieza el código
#
if __name__ == '__main__':
    # secciones = lista_de_secciones_ya_escritas()
    secciones = copy.deepcopy(LISTA_DE_SECCIONES_YA_ESCRITAS)
    comprueba_estructura(secciones)
    secciones = añade_info_de_tamaño(secciones)
    if AÑADE_NO_PUBLICADAS:
        secciones = añade_secciones_aún_no_publicadas(secciones)

    if 0:
        print("Quito algunas para filtrar y enfocarme en un tema")
        secciones = {s: d for s, d in secciones.items() if d['tema'] in ['filosofía']}

    if 0:
        for s, dat in secciones.items():
            print(s)

    # exporta_csv()
    exporta_json(secciones)

    if 1:
        print("Ordenado por importancia:")
        for s in sorted(secciones.keys(), key=lambda s: secciones[s]['importancia']):
            dat = secciones[s]
            print("%i: %s" % (dat['importancia'], s))

    if 1:
        # [Path(s['ruta']).parts for _, s in secciones.items()]
        # [print(Path(s['ruta']).parts) for _, s in secciones.items()]
        rutas_nivel_1 = list(sorted(set([Path(s['ruta']).parts[0] for _, s in secciones.items() if s['ruta']])))
        print("\nSecciones de 1r nivel:\n", "\n".join(rutas_nivel_1))

    genera_mapa_html(secciones)

    if 1:
        genera_ficheros_de_menú(secciones)
